<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html>
<head>
<title>WIENER MPOD Control Example  </title>

</head>

<body bgcolor="white" text="black" link="blue" vlink="purple" alink="red">
<span style="font-size:18pt;">WIENER MPOD Control Example 
</span><?php
    $ip='192.168.2.25';
    $community = 'guru'; //snmp community name
    snmp_set_quick_print(1);
    $ret = snmp_read_mib('WIENER-CRATE-MIB.txt');

//snmpset($ip, "guru", "outputVoltageRiseRate.1", "F", "125");

if(isset($_GET['ps'])) {
    mainPower($_GET['ps'], $ip);
}

$a = snmpwalk($ip, $community, "crate");

if(isset($_GET['channel']) & isset($_GET['power'])) {
    $channelToSwitch =$a[3+$_GET['channel']];
    switchChannel($channelToSwitch, $_GET['power'], $ip);
}

$pointer=2;
$channels=$a[$pointer];

if(isset($_GET['AllOn'])) {
    if($_GET['AllOn']=="All ON") {
    	$cycle=1;
    } else {
    	$cycle=0;
    }
    echo $cycle;
    for($i=0; $i<$channels; $i+=1) {
    	$channel=$a[$pointer+$i+1];
 	$OID="outputSwitch.$channel";
    	snmpset($ip, "guru", $OID, "i", $cycle);
    }
    echo "<meta http-equiv='refresh' content='1;url=http://wiener-us.no-ip.org/PControl/MPOD/index.php'>";
    die();
}

if(isset($_GET['setPoint'])) {
    $nom=$_GET['setPoint'];
    $chan=$_GET['channel'];
    setChannelVoltage($chan, $nom, $ip);
}

if(isset($_GET['rampSpeed'])) {
    $rampSpeed=$_GET['rampSpeed'];
    $channel=$_GET['rampChannel'];
    echo "<br>Setting Ramp Speed<br>";
    setRampSpeed($rampSpeed, $channel, $ip);
}

if(isset($_GET['current'])) {
    $iLimit=$_GET['iLimit'];
    $group=$_GET['group'];
    echo "<br>Setting Group Current Limit<br>";
    setGroupCurrentLimit($group, $iLimit, $ip);
}

if(isset($_GET['voltage'])) {
    $setPoint=$_GET['setVoltage'];
    $group=$_GET['group'];
    echo "<br>Setting Group Set Point<br>";
    setGroupVoltage($group, $setPoint, $ip);
}

if(isset($_GET['groupCycle'])) {
    $group=$_GET['group'];
    if(($_GET['groupCycle'])==1) {
        groupPowerOn($group, $ip);
    } else {
        groupPowerOff($group, $ip);
    }
}
    

$a = snmpwalk($ip, $community, "crate");



$main = $a[0];
if ($main == "ON") {
    echo "<br><br>Main Power Switch is On<br>";
} else {
    echo "<br><br>Main Power Switch is Off<br>";
}

echo "<form action=index.php name='AllOn'>
      <input type='submit' name='AllOn' value='All ON'>
      <input type='submit' name='AllOn' value='All Off'>
      </form>";



$pointer=2;
$channels=$a[$pointer];
$i=0;
$groupCount=1;

//echo "$channels channels were found";
echo "<b>Channel Group " .$groupCount. "</b><br>";

echo "<table border='1'>";
echo "<tr><th>Channel #</th>
      <th>Channel Name</th>
      <th width= 200>Nominal (V)</th>
      <th>Measured (V)</th>
      <th>Current(A)</th>
      <th>Status</th>
      <td>";

$i=0;
$oldGroup = $group=$a[$pointer+$channels*2+$i+1];
$colors = array( '#0066CC', '#FF6666', '#FFFF66', '#00CC66', '#FF66FF');
$colorIndex=0;


for ($i =0; $i<$channels; $i+=1 ) {
    $channel=$a[$pointer+$i+1];
    $name=$a[$pointer+$channels+1+$i];
    $actual=$a[$pointer+$channels*4+$i+1];
    $actual=substr($actual, 0, -6);
    $current=$a[$pointer+$channels*6+$i+1];
    $current=substr($current, 0, -6);
    $status=$a[$pointer+$channels*8+$i+1];
    $nom=$a[$pointer+$channels*9+$i+1];
    $nom=substr($nom, 0, -6);
    $group=$a[$pointer+$channels*2+$i+1];
    if ($status =="ON") {
    	$cycle="OFF";
    } else {
    	$cycle="ON";
    }


    if($group != $oldGroup) {
        $j=$i-1;
        echo "</table>";
        $rampSpeed=$a[$pointer+$channels*12+1+$j];
        $rampSpeed=explode('.', $rampSpeed);
        $rampSpeed= $rampSpeed[0];
        $lastChannel=$a[$pointer+$j+1];
        $currentLimit=getCurrentLimit($lastChannel, $ip);
	$rampForm = "rampSpeed";
        $rampForm .= $groupCount;
        $vSetForm = "vSet";
        $vSetForm .= $groupCount;
        $iSetForm = "iSet";
        $iSetForm .= $groupCount;
        
        echo "<form action=index.php name='$rampForm' 'GET'>Ramp Speed 
              <input type='text' name='rampSpeed' value='$rampSpeed' size='4'>
              &nbsp;V/S &nbsp;&nbsp;&nbsp;&nbsp;
              <input type='hidden' name='rampChannel' value='$lastChannel'>
              <input type='submit' name='setRampSpeed' value='Set'>
              </form>";
       echo "<form action=index.php name='$vSetForm' 'GET'>Group Voltage 
              <input type='text' name='setVoltage' value='$lastNom' size='6'>
              &nbsp;V &nbsp;&nbsp;&nbsp;&nbsp;
              <input type='hidden' name='group' value='$oldGroup'>
 	      <input type='hidden' name='voltage' value='1'>
              <input type='submit' name='setGroupVoltage' value='Set'>
              </form>";
       echo "<form action=index.php name='$iSetForm' 'GET'>Current Limit 
              <input type='text' name='iLimit' value='$currentLimit' size='8'>
              &nbsp;A &nbsp;&nbsp;&nbsp;&nbsp;
              <input type='hidden' name='group' value='$oldGroup'>
              <input type='hidden' name='current' value='1'>
              <input type='submit' name='setGroupVoltage' value='Set'>
              </form>";
        echo "<a href='index.php?groupCycle=1&amp;group=$oldGroup'>Group ON</a>
              <a href='index.php?groupCycle=2&amp;group=$oldGroup'>Group OFF</a>";


	echo "<br><br><br>";
        $groupCount++;
        echo "<b>Channel Group " .$groupCount. "</b><br>";
        echo "<table border='1'>";
        echo "<tr><th>Channel #</th>
              <th>Channel Name</th>
              <th width= 200>Nominal (V)</th>
              <th>Measured (V)</th>
              <th>Current(A)</th>
              <th>Status</th>
              <td>";
        $oldGroup=$group;
	$colorIndex += 1;
    }

    $color=$colors[$colorIndex];
    echo "<tr bgcolor='$color'><td width='100'><a href='details.php?channel=$channel&amp;ip=$ip'>$channel </a> </td>";
    echo "<td width='100'>$name </td>";
    echo "<td width='150'> 
    <form name='form$i' action=index.php method='GET'>
    <input type='text' name='setPoint' value='$nom' size='11'>&nbsp;
    <input type='hidden' name='channel' value='$channel'>
    <input type='submit' name='Set' value='Set'>
    
    </form></td>";
    echo "<td width='100'> $actual </td>";
    echo "<td width='100'> $current </td>";
    echo "<td width='100'> $status </td>";
    echo "<td><a href='index.php?channel=$i&amp;power=$cycle'>Power " .$cycle. "</a>
          </td></tr>"; 
    $lastNom=$actual;
    
}
        $j=$channels-1;
        echo "</table>";
        $rampSpeed=$a[$pointer+$channels*12+1+$j];
        $rampSpeed=explode('.', $rampSpeed);
        $rampSpeed= $rampSpeed[0];
        $lastChannel=$a[$pointer+$j+1];
        $currentLimit=getCurrentLimit($lastChannel, $ip);
	$rampForm = "rampSpeed";
        $rampForm .= $groupCount;
        $vSetForm = "vSet";
        $vSetForm .= $groupCount;
        $iSetForm = "iSet";
        $iSetForm .= $groupCount;
        
        echo "<form action=index.php name='$rampForm' 'GET'>Ramp Speed 
              <input type='text' name='rampSpeed' value='$rampSpeed' size='4'>
              &nbsp;V/S &nbsp;&nbsp;&nbsp;&nbsp;
              <input type='hidden' name='rampChannel' value='$lastChannel'>
              <input type='submit' name='setRampSpeed' value='Set'>
              </form>";
       echo "<form action=index.php name='$vSetForm' 'GET'>Group Voltage 
              <input type='text' name='setVoltage' value='$lastNom' size='6'>
              &nbsp;V &nbsp;&nbsp;&nbsp;&nbsp;
              <input type='hidden' name='group' value='$oldGroup'>
 	      <input type='hidden' name='voltage' value='1'>
              <input type='submit' name='setGroupVoltage' value='Set'>
              </form>";
       echo "<form action=index.php name='$iSetForm' 'GET'>Current Limit 
              <input type='text' name='iLimit' value='$currentLimit' size='8'>
              &nbsp;A &nbsp;&nbsp;&nbsp;&nbsp;
              <input type='hidden' name='group' value='$oldGroup'>
              <input type='hidden' name='current' value='1'>
              <input type='submit' name='setGroupVoltage' value='Set'>
              </form>";
        echo "<a href='index.php?groupCycle=1&amp;group=$oldGroup'>Group ON</a>
              <a href='index.php?groupCycle=2&amp;group=$oldGroup'>Group OFF</a>";

echo "<br><br>";


echo "<br><br>";
echo "<br><br>";
$a = snmpwalk($ip, $community, "crate");
foreach ($a as $val) {
    //echo "$val <br>";
}

    //echo "<meta http-equiv='refresh' content='5;url=http://wiener-us.no-ip.org/PControl/MPOD/index.php'>";



?>




<p>&nbsp;</p>
</html>

<?php

function mainPower ( $action, $ip ) 
{
    if($action == ON){
        $switch = 1;
    } elseif ($action == OFF) {
     	$switch = 0;	
    } else {
    	echo "Wrong Type of Action";
    }

    $sysMainSwitch = snmpset($ip, "private", "sysMainSwitch.0", "i", $switch);
 //echo "Power Supply is now $action";	
 
    echo "<meta http-equiv='refresh' content='2;url=http://wiener-us.no-ip.org/PControl/MPOD/index.php'>";
    die();
}


function switchChannel ($channel, $action, $ip ) 
{
    if($action == ON){
        $switch = 1;
    } elseif ($action == OFF) {
     	$switch = 0;	
    } else {
    	echo "Wrong Type of Action";
    }

    
    $OID="outputSwitch.$channel";
    
    $sysMainSwitch = snmpset($ip, "guru", $OID , "i", $switch);
 //echo "Power Supply is now $action";	
 


}

function setChannelVoltage ($channel, $voltage, $ip ) 
{   
    $OID="outputVoltage.$channel";
    //echo "<br>OID = $OID";
    //echo "<br>Voltage= $voltage";
    
    $sysMainSwitch = snmpset($ip, "guru", $OID , "F", $voltage);	

}


function setRampSpeed ($rampSpeed, $channel, $ip ) 
{  
   $OID="outputVoltageRiseRate.";
   $OID .= $channel;
   $sysMainSwitch = snmpset($ip, "guru", $OID , "F", $rampSpeed);	
 
   //echo "<meta http-equiv='refresh' content='1;url=http://wiener-us.no-ip.org/PControl/MPOD/index.php'>";
   //die();
}

function getCurrentLimit ($channel, $ip ) 
{  
   $OID ="outputConfigMaxCurrent.";
   $OID .= $channel;
   $ret = snmpget($ip, "guru", $OID);	 
   $ret=substr($ret, 0, 8);

   return $ret;
}

function setCurrentLimit ($channel, $iLimit, $ip ) 
{  
   $OID ="outputSupervisionConfigMaxCurrent.";
   $OID .= $channel;	
   $ret = snmpset($ip, "guru", $OID, "F", $iLimit);	 
   $ret=substr($ret, 0, 8);

   return $ret;
}

function setGroupCurrentLimit ($group, $iLimt, $ip )
{
    $a = snmpwalk($ip, "public", "outputIndex"); 
    foreach ($a as $name) 
    {
        if(getGroup($name, $ip) == $group) 
        {
            setCurrentLimit($name, $iLimit, $ip);
	}
    }
   echo "<meta http-equiv='refresh' content='1;url=http://wiener-us.no-ip.org/PControl/MPOD/index.php'>";
   die();

    
}

function setGroupVoltage ($group, $setPoint, $ip )
{
    $a = snmpwalk($ip, "public", "outputIndex"); 
    foreach ($a as $name) 
    {
        if(getGroup($name, $ip) == $group) 
        {
            setChannelVoltage($name, $setPoint, $ip);
	}
    }
   //echo "<meta http-equiv='refresh' content='1;url=http://wiener-us.no-ip.org/PControl/MPOD/index.php'>";
   //die();

    
}

function groupPowerOn($group, $ip)
{
    $a = snmpwalk($ip, "public", "outputIndex"); 
    foreach ($a as $name) 
    {
        if(getGroup($name, $ip) == $group) 
        {
            switchChannel($name, "ON", $ip);
	}
    }
}


function groupPowerOff($group, $ip)
{
    $a = snmpwalk($ip, "public", "outputIndex"); 
    foreach ($a as $name) 
    {
        if(getGroup($name, $ip) == $group) 
        {
            switchChannel($name, "OFF", $ip);
	}
    }
}

function getGroup ($channel, $ip)
{
    $OID ="outputGroup.";
    $OID .= $channel;
    $ret = snmpget($ip, "guru", $OID);	 
    return $ret;
}


?>
